function [DxDx,DyDy,MM]=matriceP1(v,t)
%
% Calcul des matrices de rigidité (Dxx,Dyy) et de la matrice de masse MM
% en Elements Finis P1.
%
    nv=size(v,1);
    nt=size(t,1);
    DxDx=sparse(nv,nv);
    DyDy=DxDx;
    MM=sparse(nv,nv);

    % matrice de masse élémentaire P1
    MMl=[2 1 1;
         1 2 1;
         1 1 2]/24;

    fprintf('(1...20)=');
    ntt=floor(nt/20)*20;
    j=1;
    for i=1:nt
        tl=t(i,:)';
        if(mod(i*20,ntt)==0)
            fprintf(strcat(num2str(j),' '));
            j=j+1;
        end
        S1=v(tl(1),:)';
        S2=v(tl(2),:)';
        S3=v(tl(3),:)';
        [DxDxl,DyDyl]=matriceDelem(S1,S2,S3);
        ig=tl(1:3);
        DxDx(ig,ig)=DxDx(ig,ig)+DxDxl;
        DyDy(ig,ig)=DyDy(ig,ig)+DyDyl;
        MM(ig,ig)=MM(ig,ig)+MMl*2*tl(5);

    end

    fprintf('\n');
end