function [DxDx,DyDy,MM]=matriceP1vect(v,t)
%
% Calcul des matrices de rigidité (Dxx,Dyy) et de la matrice de masse MM
% en Elements Finis P1.
% Version "vectorisée" (bcp plus rapide : facteur > 10 ...) de MatriceP1.m:
% on travaille avec des vecteurs à la place des matrices (construction des 
% matrices tout à la fin.
%
    nv=size(v,1);
    nt=size(t,1);

    % Matrice de masse élémentaire P1
    MMl=[2 1 1 ...
         1 2 1 ...
         1 1 2]/24;

    fprintf('(1...20)=');
    ntt=floor(nt/20)*20;
    j=1;

    ligne=zeros(nt*9,1);
    colonne=zeros(nt*9,1);
    DxDxval=zeros(nt*9,1);
    DyDyval=zeros(nt*9,1);
    MMval=zeros(nt*9,1);

    ind_ligne1=1;

    for i=1:nt
        tl=t(i,:)';
        if(mod(i*20,ntt)==0)
            fprintf(strcat(num2str(j),' '));
            j=j+1;
        end
        S1=v(tl(1),:)';
        S2=v(tl(2),:)';
        S3=v(tl(3),:)';
        [DxDxl,DyDyl]=matriceDelemvect(S1,S2,S3);

        ig=tl(1:3)';
        indice=ones(3,1)*ig;
        ligne(ind_ligne1:ind_ligne1+8)=indice(:);
        indice=indice';
        colonne(ind_ligne1:ind_ligne1+8)=indice(:);

        DxDxval(ind_ligne1:ind_ligne1+8)=DxDxl';
        DyDyval(ind_ligne1:ind_ligne1+8)=DyDyl';
        MMval(ind_ligne1:ind_ligne1+8)=MMl'*2*tl(5);
        ind_ligne1=ind_ligne1+9;

    end

    DxDx=sparse(ligne,colonne,DxDxval);
    DyDy=sparse(ligne,colonne,DyDyval);
    MM=sparse(ligne,colonne,MMval);

    fprintf('\n');
end